<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Origin ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Origin extends AbstractStructArrayBase
{
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Origin[]
     */
    public $Origin;
    /**
     * Constructor method for ArrayOfJP_Origin
     * @uses ArrayOfJP_Origin::setOrigin()
     * @param \StructType\JP_Origin[] $origin
     */
    public function __construct(array $origin = array())
    {
        $this
            ->setOrigin($origin);
    }
    /**
     * Get Origin value
     * @return \StructType\JP_Origin[]|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * This method is responsible for validating the values passed to the setOrigin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrigin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginForArrayConstraintsFromSetOrigin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_OriginOriginItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_OriginOriginItem instanceof \StructType\JP_Origin) {
                $invalidValues[] = is_object($arrayOfJP_OriginOriginItem) ? get_class($arrayOfJP_OriginOriginItem) : sprintf('%s(%s)', gettype($arrayOfJP_OriginOriginItem), var_export($arrayOfJP_OriginOriginItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Origin property can only contain items of type \StructType\JP_Origin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Origin value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Origin[] $origin
     * @return \ArrayType\ArrayOfJP_Origin
     */
    public function setOrigin(array $origin = array())
    {
        // validation for constraint: array
        if ('' !== ($originArrayErrorMessage = self::validateOriginForArrayConstraintsFromSetOrigin($origin))) {
            throw new \InvalidArgumentException($originArrayErrorMessage, __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Add item to Origin value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Origin $item
     * @return \ArrayType\ArrayOfJP_Origin
     */
    public function addToOrigin(\StructType\JP_Origin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Origin) {
            throw new \InvalidArgumentException(sprintf('The Origin property can only contain items of type \StructType\JP_Origin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Origin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Origin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Origin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Origin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Origin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Origin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Origin
     */
    public function getAttributeName()
    {
        return 'Origin';
    }
}
